# Class AuthConfigFactory

java.lang.Object
jakarta.security.auth.message.config.AuthConfigFactory

public abstract class AuthConfigFactory extends Object

## Nested Class Summary

Nested Classes
Modifier and Type
Class
Description
`static interface`
`AuthConfigFactory.RegistrationContext`

## Field Summary

Fields
Modifier and Type
Field
Description
`static final String`
`DEFAULT_FACTORY_SECURITY_PROPERTY`
`static final String`
`GET_FACTORY_PERMISSION_NAME`
`static final SecurityPermission`
`getFactorySecurityPermission`
Deprecated, for removal: This API element is subject to removal in a future version.
Following JEP 411
`static final String`
`PROVIDER_REGISTRATION_PERMISSION_NAME`
`static final SecurityPermission`
`providerRegistrationSecurityPermission`
Deprecated, for removal: This API element is subject to removal in a future version.
Following JEP 411
`static final String`
`SET_FACTORY_PERMISSION_NAME`
`static final SecurityPermission`
`setFactorySecurityPermission`
Deprecated, for removal: This API element is subject to removal in a future version.
Following JEP 411

## Constructor Summary

Constructors
Constructor
Description
`AuthConfigFactory()`

## Method Summary

Modifier and Type
Method
Description
`abstract String[]`
`detachListener(RegistrationListener listener, String layer, String appContext)`
`abstract AuthConfigProvider`
`getConfigProvider(String layer, String appContext, RegistrationListener listener)`
`static AuthConfigFactory`
`getFactory()`
`abstract AuthConfigFactory.RegistrationContext`
`getRegistrationContext(String registrationID)`
`abstract String[]`
`getRegistrationIDs(AuthConfigProvider provider)`
`abstract void`
`refresh()`
`abstract String`
`registerConfigProvider(AuthConfigProvider provider, String layer, String appContext, String description)`
`abstract String`
`registerConfigProvider(String className, Map<String,String> properties, String layer, String appContext, String description)`
`abstract String`
`registerServerAuthModule(ServerAuthModule serverAuthModule, Object context)`
Convenience method for registering a `ServerAuthModule` that should have the same effect as calling `registerConfigProvider(AuthConfigProvider, String, String, String)` with the implementation providing the appropriate `AuthConfigProvider` generated from the provided context.
`abstract boolean`
`removeRegistration(String registrationID)`
`abstract void`
`removeServerAuthModule(Object context)`
Convenience method for deregistering a `ServerAuthModule` that should have the same effect as calling `removeRegistration(String)`.
`static void`
`setFactory(AuthConfigFactory factory)`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

## Field Details

### DEFAULT_FACTORY_SECURITY_PROPERTY

public static final String DEFAULT_FACTORY_SECURITY_PROPERTY

See Also:
  - Constant Field Values

### GET_FACTORY_PERMISSION_NAME

public static final String GET_FACTORY_PERMISSION_NAME

See Also:
  - Constant Field Values

### SET_FACTORY_PERMISSION_NAME

public static final String SET_FACTORY_PERMISSION_NAME

See Also:
  - Constant Field Values

### PROVIDER_REGISTRATION_PERMISSION_NAME

public static final String PROVIDER_REGISTRATION_PERMISSION_NAME

See Also:
  - Constant Field Values

### getFactorySecurityPermission

@Deprecated(forRemoval=true) public static final SecurityPermission getFactorySecurityPermission
Deprecated, for removal: This API element is subject to removal in a future version.
Following JEP 411

### setFactorySecurityPermission

@Deprecated(forRemoval=true) public static final SecurityPermission setFactorySecurityPermission
Deprecated, for removal: This API element is subject to removal in a future version.
Following JEP 411

### providerRegistrationSecurityPermission

@Deprecated(forRemoval=true) public static final SecurityPermission providerRegistrationSecurityPermission
Deprecated, for removal: This API element is subject to removal in a future version.
Following JEP 411

## Constructor Details

### AuthConfigFactory

public AuthConfigFactory()

## Method Details

### getFactory

public static AuthConfigFactory getFactory()

### setFactory

public static void setFactory(AuthConfigFactory factory)

### getConfigProvider

public abstract AuthConfigProvider getConfigProvider(String layer, String appContext, RegistrationListener listener)

### registerConfigProvider

public abstract String registerConfigProvider(String className, Map<String,String> properties, String layer, String appContext, String description)

### registerConfigProvider

public abstract String registerConfigProvider(AuthConfigProvider provider, String layer, String appContext, String description)

### removeRegistration

public abstract boolean removeRegistration(String registrationID)

### detachListener

public abstract String[] detachListener(RegistrationListener listener, String layer, String appContext)

### getRegistrationIDs

public abstract String[] getRegistrationIDs(AuthConfigProvider provider)

### getRegistrationContext

public abstract AuthConfigFactory.RegistrationContext getRegistrationContext(String registrationID)

### refresh

public abstract void refresh()

### registerServerAuthModule

public abstract String registerServerAuthModule(ServerAuthModule serverAuthModule, Object context)
Convenience method for registering a `ServerAuthModule` that should have the same effect as calling `registerConfigProvider(AuthConfigProvider, String, String, String)` with the implementation providing the appropriate `AuthConfigProvider` generated from the provided context.

Parameters:
  `serverAuthModule` - The `ServerAuthModule` to register
  `context` - The associated application context
Returns:
  A string identifier for the created registration
Since:
  Authentication 3.0

### removeServerAuthModule

public abstract void removeServerAuthModule(Object context)
Convenience method for deregistering a `ServerAuthModule` that should have the same effect as calling `removeRegistration(String)`.

Parameters:
  `context` - The associated application context
Since:
  Authentication 3.0